/*
 * Copyright 2016 - 2024 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include <ox/std/error.hpp>

namespace studio {

class NoChangesException: public ox::Exception {
	public:
		inline NoChangesException(): ox::Exception(OxError(1, "Command makes no changes.")) {}
};

class UndoCommand {
	public:
		virtual ~UndoCommand() noexcept = default;
		virtual void redo() noexcept = 0;
		virtual void undo() noexcept = 0;
		[[nodiscard]]
		virtual int commandId() const noexcept = 0;
		virtual bool mergeWith(UndoCommand const*cmd) noexcept;
};

}
